'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2007
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
Imports DotNetNuke
Imports DotNetNuke.Services.Localization
Imports DotNetNuke.Entities.Users

Namespace RTP.ForgottenUser
    Public MustInherit Class ForgottenUser
        Inherits ForgottenUserBase

#Region "Private Members"
        Private AdminUseridArray As New ArrayList
#End Region

#Region "Event Handlers"

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            divMessages.Visible = False

            valEmail2.ValidationExpression = CStr(DotNetNuke.Entities.Users.UserController.GetUserSettings(PortalId)("Security_EmailValidation"))
            Try
            Catch exc As Exception 'Module failed to load
                Services.Exceptions.ProcessModuleLoadException(Me, exc)
                'ProcessModuleLoadException(Me, exc)
            End Try
        End Sub

        Private Sub cmdRet_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdRet.Click
            Dim SendAdmins As Boolean = False

            SendAdmins = Settings.SendAdminID

            Dim NumberofEmailsSent As Integer = 0

            Dim UserNames As String = ""

            Dim AddUser As Boolean = False

            Dim UserArray As ArrayList = DotNetNuke.Entities.Users.UserController.GetUsersByEmail(PortalId, txtEmail.Text, 0, 1000, 1000)
            If Not SendAdmins Then
                Dim objRoleCtl As New DotNetNuke.Security.Roles.RoleController
                Dim AdminArray As ArrayList = objRoleCtl.GetUsersByRoleName(PortalId, PortalSettings.AdministratorRoleName)
                For Each objUser As Entities.Users.UserInfo In AdminArray
                    AdminUseridArray.Add(objUser.UserID)
                Next
            End If

            'For Each objUser As UserInfo In UserArray
            Dim ToUser As New UserInfo
            For Each objUser As UserInfo In UserArray
                Dim objMem As UserMembership = objUser.Membership
                If ShouldUserBeSent(objUser, SendAdmins) Then
                    If NumberofEmailsSent = 0 Then
                        UserNames = objUser.Username
                        ToUser = objUser
                    Else
                        UserNames = UserNames & ", " & objUser.Username
                    End If
                    'Send it
                    NumberofEmailsSent += 1
                End If
            Next
            If NumberofEmailsSent = 0 Then
                lblMessages.Text = Localization.GetString("InvalMessage", LocalResourceFile)
                divMessages.Visible = True
                lblMessages.CssClass = "dnnFormMessage dnnFormValidationSummary"
            Else
                Dim MailBody As String = String.Format(Localization.GetString("MailBody", LocalResourceFile), UserNames)
                Try
                    Dim ToUsers As New System.Collections.Generic.List(Of UserInfo)()
                    ToUsers.Add(ToUser)
                    Dim objNotification As New Components.Integration.Notifications
                    objNotification.SendUsernameNotification(Localization.GetString("MailSubject", LocalResourceFile), MailBody, ToUsers, PortalSettings.AdministratorId, PortalId)

                Catch exc As Exception 'Email Failed to Send
                    Services.Exceptions.ProcessModuleLoadException(Me, exc)
                End Try
                lblMessages.Text = String.Format(Localization.GetString("ValMessage", LocalResourceFile), NumberofEmailsSent)
                divMessages.Visible = True
                lblMessages.CssClass = "dnnFormMessage dnnFormSuccess"
            End If
            Dim objEventCtl As New DotNetNuke.Services.Log.EventLog.EventLogController
            objEventCtl.AddLog("ForgottenUser", String.Format(Localization.GetString("LogMessage", LocalResourceFile), txtEmail.Text, lblMessages.Text), PortalSettings, UserId, Services.Log.EventLog.EventLogController.EventLogType.ADMIN_ALERT)
        End Sub
#End Region

#Region "Private Methods "

        Private Function ShouldUserBeSent(ByVal objUser As Entities.Users.UserInfo, ByVal SendAdmins As Boolean) As Boolean
            'The email if for a SuperUser, they will never be sent
            If objUser.IsSuperUser Then
                Return False
            End If

            'After ther Super User, we don't care what role they are, they will be sent
            If SendAdmins Then
                Return True
            End If

            'If the user is an admin, this will return true
            If AdminUseridArray.Contains(objUser.UserID) Then
                Return False
            Else
                Return True
            End If
        End Function


#End Region

#Region "Optional Interfaces"
#End Region

    End Class

End Namespace